      SUBROUTINE a_lm(Lmn,Lmx,Nx,Vnyq,eps,phi2,
     +          Nmx,Nmp,Jmx, x,pw,f,Nph,
     +          wsave,cf,apm,bpm,
     +          K_fast,Ksym,Kml)
c     SUBROUTINE a_lm(Lmn,Lmx,Nx,Vnyq,eps,phi2)
c       include 'mem.inc'
	 IMPLICIT REAL*8(a-h,o-y)
C       parameter(Nmx=2001,Jmx=(Nmx+1)/2,Nmp=2*Nmx)
C       common/main/ x(Nmx),pw(Nmx),f(Nmx,Nmp),Nph(Nmx)
C   service arrays
C       common/serv/ wsave(2*Nmp+15),cf(Nmp)
C       common/abpm/ apm(0:Jmx,Nmx),bpm(0:Jmx,Nmx)
C       common/key/K_alm_map,Kx,K_fast,Ksym,Kml

	DIMENSION x(Nmx),pw(Nmx),f(Nmx*Nmp),Nph(Nmx)
	DIMENSION apm((Jmx+1)*Nmx),bpm((Jmx+1)*Nmx)
	DIMENSION wsave(2*Nmp+15),cf(Nmp)

C   input parameters: x(Nx) - coordinates on
C   the sphere, f(Nx,Nph(ix)) - signal.
C   Nph - number of cells vs. x
C   0< phi < phi2 for the direct transformation
C   output: - f(l,m+1) - real a_lm, f(l,Lmx+m+2) - imag a_lm,
c   a((l,-m)=(-1)^m a(l,m)*
c* -------------------------------------------------------------------- *

C totaly zero, because of memory allocation with 'calloc' in C
c     DO m=0,Jmx
c        mm = m * Nmx
c        DO ix=1,Nmx
cc          apm(m,ix)=0.
cc          bpm(m,ix)=0.
c           apm(mm+ix)=0.
c           bpm(mm+ix)=0.
c        ENDDO
c     ENDDO

      i_dip_flag = 0
      if(Kml.eq.100.and.Lmx.lt.0) then
	  Kml = -1
	  Lmx = -Lmx
	  i_dip_flag = 1
      endif

      if(Kml.eq.0.and.Lmx.lt.0) then
	   Lmx = -Lmx
	   i_dip_flag = 1
      endif

C   loop over phi - SUM_phi[f*exp(-m*phi)
C   for rectangular map x1< x< x2, 0< phi < phi2
        if(K_fast.lt.0) call alm_phi(Nmx,Nmp,Jmx,Lmx,
     +          Vnyq,Nx,Nph,f,phi2,wsave,apm,bpm) 
C   fast-fourier, 
        print*,'alm-fast'
        if(K_fast.gt.0) call alm_fast3(Nmx,Nmp,Nx,Jmx,
     +                Lmx,Vnyq,Nph,f,cf,apm,bpm,wsave)


C$omp parallel do
C$omp+ shared(Nmx, Nmp, f)
C$omp+ private(i, mm, j)
	do i=1,Nmx
	     mm = (i-1) * Nmp
	     do j=1,Nmp
		    f(mm+j)=0
	     enddo
	enddo
C$omp end parallel do

	print *, 'Nx=', Nx, ' Jmx=', Jmx, ' Lmax=', Lmx
	suma=0
	sumb=0


C$omp parallel do 
C$omp+ shared(Nx, Lmx, apm, bpm) 
C$omp+ private(ix, im, mm) 
C$omp+ reduction(+:suma, sumb)
	do ix=1,Nx
	     do m=0,Lmx
		    mm = m * Nmx
		    suma=suma+apm(mm+ix)**2
		    sumb=sumb+bpm(mm+ix)**2
	     enddo
	enddo
C$omp end parallel do
        print*,'s_amp=',suma,' s_bpm=',sumb

C   loop over l - SUM_l[a_{lm}P_l^m(x_p)]
	if(i_dip_flag.eq.1) then
	     call alm_dipole(Nmx,Nmp,Jmx,Lmx,Ksym,Nx,x,apm,bpm,f)
	endif

	if(Kml.gt.0) then
          print*,'alm-lgndr-L'
          call alm_lgndr_L(Nmx,Nmp,Jmx,Lmn,Lmx,Ksym,
     +                  eps,Nx,x,apm,bpm,cf,wsave,f)
        endif
        if(Kml.lt.0) then
          print*,'alm-lgndr-M'
          call alm_lgndr_M(Nmx,Nmp,Jmx,Lmn,Lmx,Ksym,
     +                  eps,Nx,x,apm,bpm,cf,wsave,f)
        endif
        RETURN
      END
C-----------------------------------------------------------
        SUBROUTINE alm_lgndr_M(Nmx,Nmp,Jmx,Lmn,Lmx,Ksym,
     +                  eps,Nx,x,apm,bpm,glm,c,f)
C   loop over l - SUM_l[a_{lm}P_l^m(x_p)]
C   input: x(Nx),Nph(Jmx),apm(0:Jmx,Nmx),bpm(0:Jmx,Nmx)
C   ouput: f(Nmx,Nmp)
      IMPLICIT REAL*8(a-h,o-y)  
c     DIMENSION f(Nmx,Nmp),x(Nx),Nph(Nmx)
c     DIMENSION apm(0:Jmx,Nmx),bpm(0:Jmx,Nmx)
      DIMENSION f(Nmx*Nmp),x(Nx),Nph(Nmx)
      DIMENSION apm((Jmx+1)*Nmx),bpm((Jmx+1)*Nmx)
      DIMENSION c(2*Lmx+2),glm(Lmx+1)


      pi=4.*atan(1.d0)
c     cnorm=-1./dsqrt(pi)
c     cnorm=cnorm/0.70710678118654752440d0
      cnorm=-1./dsqrt(2.*pi)
      Kx=Nx
      if(Ksym.gt.0) Kx=(Nx+1)/2

!$omp parallel do
!$omp+ shared(Lmx,eps,Nmp,f,apm,bpm,Kx,Nx,x,cnorm)
!$omp+ private(L,LL,jx,ax,ix,xc,glm,sa,sb,m,mm,mb,cmm,c,L0)
      DO m=0,Lmx                        ! for all m
	 mm = m * Nmx
         mb=Lmx+m+2
         call start_clm(Lmx,m,cmm,c)
         DO ix=1,Kx                     ! for all x(ix)
	    xc=x(ix)
	    call lgndr_M(Lmx,m,cmm,c,xc,glm)
	    L0=m
	    if(L0.lt.Lmn) L0=Lmn

	    DO L=L0,Lmx              ! for all m<L<Lmx
		if(dabs(glm(L+1)).gt.eps) then
		  LL = L * Nmp
c                 f(L,m+1)=f(L,m+1)+glm(L+1)*apm(m,ix)
c                 f(L,mb)=f(L,mb)+glm(L+1)*bpm(m,ix)
		  f(LL+m+1) = f(LL+m+1) + glm(L+1)*apm(mm+ix)
		  f(LL+mb)  = f(LL+mb)  + glm(L+1)*bpm(mm+ix)

		  IF(Kx.lt.Nx) THEN      ! for symmetric x
		     jx=Nx-ix+1
		     if(ix.lt.jx) then
			  ax=1-2*mod((L+m),2)
c                         f(L,m+1)=f(L,m+1)+ax*glm(L+1)*apm(m,jx)
c                         f(L,mb)=f(L,mb)+ax*glm(L+1)*bpm(m,jx)
			  f(LL+m+1)= f(LL+m+1)+ax*glm(L+1)*apm(mm+jx)
			  f(LL+mb) = f(LL+mb) +ax*glm(L+1)*bpm(mm+jx)
		     endif
		  ENDIF      ! for symmetric x
		endif        ! for glm< eps
	    ENDDO            ! for all m<L< Lmx
	 ENDDO               ! for all x(ix)

	 DO L=L0,Lmx
	    LL = L * Nmp
C normalization and record of alm
c           f(L,m+1)=cnorm*f(L,m+1)
c           f(L,mb)=-cnorm*f(L,mb)

	    f(LL+m+1)=cnorm*f(LL+m+1)
	    f(LL+mb)=-cnorm*f(LL+mb)
         ENDDO
      ENDDO                             ! over all m
!$omp end parallel do
      return
      end

C-----------------------------------------------------------
        SUBROUTINE alm_lgndr_L(Nmx,Nmp,Jmx,Lmn,Lmx,Ksym,
     +                         eps,Nx,x,apm,bpm,glm,abc,f)
C   loop over l - SUM_l[a_{lm}P_l^m(x_p)]
C   input: x(Nx),apm(0:Jmx,Nmx),bpm(0:Jmx,Nmx)
C   ouput: f(Nmx,Nmp)
      IMPLICIT REAL*8(a-h,o-y)
c     DIMENSION f(Nmx,Nmp),x(Nx)
c     DIMENSION apm(0:Jmx,Nmx),bpm(0:Jmx,Nmx)
      DIMENSION f(Nmx*Nmp),x(Nx)
      DIMENSION apm((Jmx+1)*Nmx),bpm((Jmx+1)*Nmx)
      DIMENSION abc(4*Lmx),glm(2*Lmx+1)
C     glm=cf(Nmp), abc=wsave(2*Nmp+15), Nmp>2*Lmax

      Kx=Nx
      if(Ksym.gt.0) Kx=(Nx+1)/2
      mb=Lmx+2
      DO ix=1,Kx              ! for all x(ix)
           xc=x(ix)
           call lgndr_0(Lmx,xc,glm)      ! P_L^0(ix),L<Lmx
           DO L=Lmn,Lmx                  ! for all L
C   for m=0
	       LL = L * Nmp
	       LL0=Lmx+L+1
	       if(dabs(glm(LL0)).gt.eps) then
	       f(LL+1)=f(LL+1)+glm(LL0)*apm(0+ix)
c              f(L,1)=f(L,1)+glm(LL0)*apm(0,ix)
c c            f(L,mb)=f(L,mb)+glm(LL0)*bpm(0,ix)
               IF(Kx.lt.Nx) THEN
                 jx=Nx-ix+1
                 if(jx.gt.ix) then
		   ax=1-2*mod(L,2)
		   f(LL+1)=f(LL+1)+glm(LL0)*ax*apm(0+jx)
c                  f(L,1)=f(L,1)+glm(LL0)*ax*apm(0,jx)
c c                f(L,mb)=f(L,mb)+glm(LL0)*ax*bpm(0,jx)
                 endif
               ENDIF
               endif            ! for glm< eps
C   for m=1, ..., L
             call lgndr_L(Lmx,L,xc,abc,glm) ! P_L^m(ix),1<m<L
             DO m=1,L
		 if(dabs(glm(m)).gt.eps) then
		     mm = m * Nmx
c                    f(L,m+1)=f(L,m+1)+glm(m)*apm(m,ix)
c                    f(L,mb+m)=f(L,mb+m)+glm(m)*bpm(m,ix)
		     f(LL+m+1) = f(LL+m+1) +glm(m)*apm(mm+ix)
		     f(LL+mb+m)= f(LL+mb+m)+glm(m)*bpm(mm+ix)
		     IF(Kx.lt.Nx) THEN
		       jx=Nx-ix+1
		       if(jx.gt.ix) then
			 ax=1-2*mod((L+m),2)
c                        f(L,m+1)=f(L,m+1)+glm(m)*ax*apm(m,jx)
c                        f(L,mb+m)=f(L,mb+m)+glm(m)*ax*bpm(m,jx)
			 f(LL+m+1) =f(LL+m+1) +glm(m)*ax*apm(mm+jx)
			 f(LL+mb+m)=f(LL+mb+m)+glm(m)*ax*bpm(mm+jx)
		       endif
		     ENDIF
		 endif              ! for glm< eps
             ENDDO              ! over all m
           ENDDO                ! over all L
      ENDDO                  ! end for x(ix)

C normalization and record of alm
      pi=4.*atan(1.d0)
      cnorm=-1./dsqrt(2.*pi)
      DO L=Lmn,Lmx                    ! for all L
	   LL = L * Nmp
	   DO m=0,L                     ! for all m
c            f(L,m+1)=cnorm*f(L,m+1)
c            f(L,mb+m)=-cnorm*f(L,mb+m)
	     f(LL+m+1)  = cnorm*f(LL+m+1)
	     f(LL+mb+m) = -cnorm*f(LL+mb+m)
           ENDDO                        ! over all m
c          f(L,1)=0.70710678d0*f(L,1)   ! m=0
c          f(LL+1)=0.70710678118654752440d0*f(LL+1) ! m=0
      ENDDO                                         ! over all l
      return
      end

C-----------------------------------------------------------
	SUBROUTINE alm_dipole(Nmx,Nmp,Jmx,Lmx,Ksym,
     +                  Nx,x,apm,bpm,f)
C   loop over l - SUM_l[a_{lm}P_l^m(x_p)]
C   input: x(Nx),Nph(Jmx),apm(0:Jmx,Nmx),bpm(0:Jmx,Nmx)
C   ouput: f(Nmx,Nmp)
      IMPLICIT REAL*8(a-h,o-y)
c     DIMENSION f(Nmx,Nmp),x(Nx)                !,Nph(Nmx)
      DIMENSION f(Nmx*Nmp),x(Nx)                !,Nph(Nmx)
      DIMENSION c(2*Lmx+2),glm(Lmx+1)
c     DIMENSION apm(0:Jmx,Nmx),bpm(0:Jmx,Nmx)
      DIMENSION apm((Jmx+1)*Nmx),bpm((Jmx+1)*Nmx)

	Kx=Nx
	if(Ksym.gt.0) Kx=(Nx+1)/2
c                                       ! for m=0,1,-1
	mb=Lmx+3
	L1=Nmp
	DO ix=1,Kx                     ! for all x(ix)
	   xc=-dsqrt(1.-x(ix)**2)
c          f(1,1)=f(1,1)+x(ix)*apm(0,ix)   ! a_10
c          f(1,2)=f(1,2)+xc*apm(1,ix)      ! a_11
c          f(1,mb)=f(1,mb)+xc*bpm(1,ix)    ! a_1-1
	   f(L1+1) =f(L1+1) +x(ix)*apm(ix)       ! a_10
	   f(L1+2) =f(L1+2) +xc*apm(Nmx+ix)      ! a_11
	   f(L1+mb)=f(L1+mb)+xc*bpm(Nmx+ix)      ! a_1-1
	   IF(Kx.lt.Nx) THEN  ! for symmetric x
	      jx=Nx-ix+1
	      if(ix.lt.jx) then
c               f(1,1)=f(1,1)-x(ix)*apm(0,jx)  ! a_10
c               f(1,2)=f(1,2)+xc*apm(1,jx)     ! a_11
c               f(1,mb)=f(1,mb)+xc*bpm(1,jx)   ! a_1-1
		f(L1+1) =f(L1+1) -x(ix)*apm(jx)      ! a_10
		f(L1+2) =f(L1+2) +xc*apm(Nmx+jx)     ! a_11
		f(L1+mb)=f(L1+mb)+xc*bpm(Nmx+jx)     ! a_1-1
	      endif
	   ENDIF              ! for symmetric x
	ENDDO                 ! for all x(ix)

C normalization and record of alm
	pi=4.*atan(1.d0)
	cnorm=-dsqrt(1.5/pi)
c       f(1,1)=0.70710678d0*cnorm*f(1,1)     ! a_10
c       f(1,2)=cnorm*f(1,2)                  ! a_11
c       f(1,mb)=cnorm*f(1,mb)                ! a_1-1
	f(L1+1) =0.70710678d0*cnorm*f(L1+1)     ! a_10
	f(L1+2) =0.5*cnorm*f(L1+2)              ! a_11
	f(L1+mb)=-0.5*cnorm*f(L1+mb)            ! a_1-1

	print *, f(L1+1), f(L1+2), f(L1+mb)

	return
	end
