#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

/*
 *  some function over a_lm-s
 *
 *  created by V.O. 18/04/2013
 *  last changes ...
 */
#include "glesp.h"

#define PR      fprintf
#define ER      stderr
#define ST      stdout

/* shift multipoles by L and M */
void shift_multipoles(alm, lmax, nbuf, sd_l, sd_m)
double **alm;
int *lmax, *nbuf;
int sd_l, sd_m; /* values for shifting by L and M */
{
    register int l, m;
    double *a = (double *)0, *b = (double *)0;
    int lmx = *lmax, nb = *nbuf;

    if (sd_l > 0) {lmx = *lmax + sd_l; nb = 2 * (lmx + 1);}
    if ((a = (double*)calloc((unsigned)((lmx+1)*nb),sizeof *a))==(double*)0){
nomem:
	PR(ER, "%s: no memmory for temporal array...\n", myname);
	exit(1);
    }
    if ((b = (double*)calloc((unsigned)((lmx+1)*nb),sizeof *b))==(double*)0)
	goto nomem;

    if (sd_m) {
	for (l=0; l <= *lmax; l++) {
	    int ll = l * *nbuf, m1, m2;
	    int lla = l * nb;
	    if (sd_m > 0) {
		m1 = 0; m2 = l - sd_m;
	    } else { /* if (sd_m < 0) */
		m1 = -sd_m; m2 = l;
	    }
	    for (m=m1; m<=m2; m++)  {
		b[lla+m]       = (*alm)[ll + m+sd_m];
		b[lla+lmx+1+m] = (*alm)[ll + *lmax+1+m+sd_m];
	    }
	    b[lla+lmx+1] = 0.0;
	}
    } else {
	for (l=0; l <= *lmax; l++) {
	    int ll = l * *nbuf;
	    int lla = l * nb;
	    for (m=0; m<=l; m++) {
		b[lla+m] = (*alm)[ll+m];
		b[lla+lmx+1+m] = (*alm)[ll + *lmax+1+m];
	    }
	    b[lla+lmx+1] = 0.0;
	}
    }

    if (sd_l > 0) {
	int ls = lmx - sd_l;
	for (l=0; l<=ls; l++) {
	    int ll = l * nb;
	    int lls = (l+sd_l) * nb;
	    for (m=0; m<=l; m++) {
		int mm = lmx+1+m;
		a[ll+m]  = b[lls+m];
		a[ll+mm] = b[lls+mm];
	    }
	}
    } else if (sd_l < 0) {
	int ls = -sd_l;
	for (l=ls; l<=lmx; l++) {
	    int ll = l * nb;
	    int lls = (l+sd_l) * nb;
	    for (m=0; m<=l; m++) {
		int mm = lmx+1+m;
		a[ll+m]  = b[lls+m];
		a[ll+mm] = b[lls+mm];
	    }
	}
    }

    if (sd_l == 0 && sd_m) {
	for (l=0; l<=lmx; l++) {
	    int ll = l * nb;
	    a[ll]  = b[ll];
	    for (m=1; m<=l; m++) {
		int mm = lmx+1+m;
		a[ll+m]  = b[ll+m];
		a[ll+mm] = b[ll+mm];
	    }
	}
    }

    if (b != (double *)0)  free((void *)b);
    free((void *)(*alm));

    *alm = a;
    *nbuf = nb;
    *lmax = lmx;

    return;
}
