#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define     PR  fprintf
#define     ER  stderr
char *myname;

int main(argc, argv)
int argc;
char **argv;
{
    register int i;
    int n = argc - 1, l, lmax=0;
    double **r, cor;
    FILE *fp;
    char str[81], file[81];

    myname = argv[0];

    if (argc < 2) {
	PR(ER, "%s: no input files\n", myname);
	exit(1);
    }

    strcpy(file, argv[1]);
    if((fp = fopen(file, "r")) == (FILE *)0) {
badfile:
	PR(ER, "%s: I can not open file '%s'...\n", myname, file);
	exit(1);
    }
    while(fgets(str, 80, fp) != NULL) {
	if( *str == '#' || *str == '\n' )
		continue;
	sscanf(str, "%d%lf", &l, &cor);
	if (lmax < l) lmax = l;
    }
    fclose(fp);
PR(ER, "lmax=%d, n=%d\n", lmax, n);

    if((r = (double **)calloc(n, sizeof *r)) == (double **)0) {
nomem:
	PR(ER, "%s: no memory\n", myname);
	exit(1);
    }
    for(i=0; i<n; i++) {
	if((r[i] = (double *)calloc(lmax+1, sizeof **r)) == (double *)0)
	    goto nomem;

	 strcpy(file, argv[i+1]);
	 if((fp = fopen(file, "r")) == (FILE *)0)
	     goto badfile;

	 while(fgets(str, 80, fp) != NULL)  {
	     if( *str == '#' || *str == '\n' )
		     continue;
	     sscanf(str, "%d%lf", &l, &cor);
	     if (lmax < l) continue;
	     r[i][l] = cor;
	 }
	 fclose(fp);
    }

    for(l=2; l<=lmax; l++) {
	double sum = 0.0, sig = 0.0;
	for(i=0; i<n; i++)  sum += r[i][l];
	sum /= n;
	for(i=0; i<n; i++) {
	    double d = r[i][l] - sum;
	    sig += d * d;
	}
	sig = sqrt(sig/n);
	PR(stdout, "%4d %12.5e\n", l, sig);
    }

    exit(0);
}
