#include <stdio.h>
#include <stdlib.h>
#include <fftw3.h>

#define PR  fprintf
#define ER  stderr

/* coeffcients from map */
void fftw_b(n, f_in, f_out)
register double *f_in, *f_out;
register int n;
{
     static fftw_plan p;
     static int n_old = 0;
     register int i;
     int n2 = (n+1)/2;

     if (n_old != 0 && n_old != n)
	    fftw_destroy_plan(p);

     if (n_old != n) {
	    p = fftw_plan_r2r_1d(n, f_in, f_out, FFTW_R2HC, FFTW_ESTIMATE);
	    n_old = n;
	    fftw_execute(p);
     } else {
	    fftw_execute_r2r(p, f_in, f_out);
     }

     f_in[0] = f_out[0];
     for (i=1; i<n2; i++) {
	    register double *fi = f_in + i + i;
	    *(fi-1) = f_out[i];
	    *fi     = f_out[n-i];
     }
     return;
}

/* map from coefficients */
void fftw_f(n, f_in, f_out)
register double *f_in, *f_out;
register int n;
{
     static fftw_plan p;
     static int n_old = 0;
     register int i;
     int n2 = (n+1)/2;

     if (n_old != 0 && n_old != n)
	    fftw_destroy_plan(p);

     f_out[0] = f_in[0];
     for (i=1; i<n2; i++) {
	    register double *fi = f_in + i + i;
	    f_out[i]   = *(fi-1);
	    f_out[n-i] = *fi;
     }
     /* n is even */
     if (n%2==0)
	     f_out[n2] = 0;

     /* read from f_out and write to f_in */
     if (n_old != n) {
	    p = fftw_plan_r2r_1d(n, f_out, f_in, FFTW_HC2R, FFTW_ESTIMATE);
	    n_old = n;
	    fftw_execute(p);
     } else {
	    fftw_execute_r2r(p, f_out, f_in);
     }

     return;
}
