ccc  f77 -C -bytereclen -backslash -o lgtst.x lgtst.f

        IMPLICIT REAL*8(a-h,o-y)
	parameter(Nmx=1001,Jmx=(Nmx+1)/2,Nmp=2*Nmx)
        dimension x(Nmx),pw(Nmx),f(Nmx,Nmp),Nph(Nmx)
C   service arrays
	dimension wsave(2*Nmp+15),cf(Nmp),cc(2,Nmx)
	DIMENSION glm_m(Nmx),glm_L(Nmx),glm_o(Nmx)
	character*120 RDNAME,recrdname
	character*4 nnm,mmp,mnm,knm,dtt
	character*3 lm
	character*1 sc
C here: x(Nmx),pw(Nmx) - coordinates and weights for cos(theta)
C       pw(Nmx) is used for map preparation in signal 
C               and testing integrals
C       Nph(ix) - cell's numbers for a given x, 
C       is defined in USER-CODE "coord" together with x(ix)
C       Nmp - max number of cells
C	Jmx - max value of Lmx				
C       f(Nx,Nph(ix)) - map (for alm preparation),
C	f(Lmx,2*Lmx+2)	alm for map preparation
C       wsave,cf,apm,bpm - service arrays. 

	OPEN(1,FILE='cmm.tbl',STATUS='OLD')
	read(1,'(A)') aa
	read(1,'(A)') aa
	read(1,'(A)') RDNAME
	read(1,'(A)') recrdname
	read(1,'(A)') aa
	read(1,*) K_alm_map,Kx,K_fast,Ksym,Kml,Num
	read(1,'(A)') aa
	read(1,*) Nx,x1,x2,Nphi,phi2
	read(1,'(A)') aa
	read(1,*) Lmn,Lmx,Vnyq,Kl,Ml
	close(1)
	
C   control of input parameters
	call control(Nmx,Nmp,Jmx,K_fast,Nx,Nphi,Lmx,Kl,Ml)
	print*,'Kx=',Kx,' K_fast=',K_fast,
     +			' Ksym=',Ksym,' Kml=',Kml

C    name of record file
	if( Ml.ge.0) sc='c'
	if( Ml.lt.0) sc='s'
	if(K_alm_map.lt.0) mmp='alm_'
	if(K_alm_map.gt.0) mmp='map_'
	if(K_fast.gt.0) dtt='.fst'
	if(K_fast.lt.0) dtt='.dat'
	if(Kml.gt.0) lm='_L_'
	if(Kml.lt.0) lm='_M_'

	Kmm=abs(Ml)
        mnm=char(ichar('0')+mod(int(Kmm/1000),10))//
     *  char(ichar('0')+mod(int(Kmm/100),10))//
     *  char(ichar('0')+mod(int(Kmm/10),10))//
     *  char(ichar('0')+mod(Kmm,10))

        knm=char(ichar('0')+mod(int(Kl/1000),10))//
     *  char(ichar('0')+mod(int(Kl/100),10))//
     *  char(ichar('0')+mod(int(Kl/10),10))//
     *  char(ichar('0')+mod(Kl,10))

        nnm=char(ichar('0')+mod(int(Num/1000),10))//
     *  char(ichar('0')+mod(int(Num/100),10))//
     *  char(ichar('0')+mod(int(Num/10),10))//
     *  char(ichar('0')+mod(Num,10))

        CALL get_name(recrdname,ipr,jpr)
        OPEN(UNIT=10, FILE=recrdname(ipr:jpr)//mmp//
     +	knm//'_'//mnm//'_'//nnm//sc//lm//dtt,STATUS='unknown')
	print*,mmp//knm//'_'//mnm//'_'//nnm//sc//dtt

	print*,'Kl=',Kl,' Ml=',Ml,' Nx=',Nx,' Lmx=',Lmx
	 write(10,10)
  10	 format(3x,'Kfst',2x,'Kx',4x,'Nx',5x,'Nphi',5x,'Lmn',
     +	 5x,'Lmx',5x,'Ksym',5x,'Kml',5x,'Kl',7x,'Ml')
	 write(10,11) k_fast,Kx,Nx,Nphi,Lmn,Lmx,Ksym,
     +		Kml,Kl,Ml
  11	 format(2I5,8I8)

C-----------------------------------------------------
C   x1 & x2 - min and max values of cos(theta)
C   x(i),pw(i), 1<i<Nx - coordinates and weights
C   Nph(Nx) - numbers of cells over phi for a given x
	x1=-1.
	x2=1.
	phi2=8.d0*atan(1.d0)
        call coord(Kx,K_fast,x1,x2,phi2,x,pw,Nx,Nph,Nphi)

	print*,'Kl=',Kl,' Ml=',Ml
	  call map_art(Nmx,Nmp,Lmx,Kl,Ml,f,Nx,x,pw,
     +	   cf,cc,wsave,glm_m,glm_L,glm_o)

	END

C -------------------------------------------------------------------- *
	SUBROUTINE map_art(Nmx,Nmp,Lmx,Kl,Ml,f,Nx,x,pw,
     +		cp,cc,c,glm_m,glm_L,glm_o)
      IMPLICIT REAL*8(a-h,o-y)
	dimension f(Nmx,Nmp),x(Nx),pw(Nx)
        DIMENSION c(4*Lmx),cm(4*Lmx),cp(Nmp),cc(2,Nmx)
	DIMENSION glm_m(Nmx),glm_L(Nmx),glm_o(Nmx),glm_0(Nmx)
	
	m=abs(Ml) 
	mm=0

	sumx=0
	sum1=0
	sum2=0
	sum3=0
	sum4=0
	sum5=0
	sum6=0
	sr12=0
	sr34=0
	sp=0
      DO j=1,4*Kl+2
	c(j)=0
      ENDDO
c       DO j=1,2*Kl+1
c	glm(j)=0
c      ENDDO
      DO j=1,Nmp
	 cp(j)=0
         DO i=1,Nmx
            f(i,j)=0.
         ENDDO
       ENDDO
	write(10,20)
  20    format(8x,'x',13x,'P0M',13x,'P0L',
     +		12x,'PLM',12x,'PLL',12x,'PLMO')
C   recurrent relations for F_{lm}(x)
	call start_clm(Lmx,mm,cm0,cp)
	call start_clm(Lmx,m,cmm,cm)
	call start_clmm(Nmx,Lmx,m,cmn,cc)

c	do i=1,10
c	  write(*,11) cm(i),cc(1,i),cm(Lmx+i),cc(2,i),cp(i)
 11	  format(5e12.4)
c	enddo

	do ix=1,Nx
           xc=x(ix)
	   sumx=sumx+pw(ix)
	   f(ix,1)=xc
	   call lgndr_M(Lmx,mm,cm0,cp,xc,glm_0)
c   P(0,0),P(0,1),P(0,2)...P(0,Kl) 
	   f(ix,2)=glm_0(mm+Kl+1)		! P^mm_Kl
	   sum1=sum1+f(ix,2)**2*pw(ix)

	   call lgndr_M(Lmx,m,cmm,cm,xc,glm_m)
c	   f(ix,4)=glm_m(m+1)		! P^m_Kl
	   f(ix,4)=glm_m(m+Kl)		! P^m_Kl
c   P(m,m),P(m,m+1),P(m,m+2)...P(m,Kl) 
	   sum3=sum3+f(ix,4)**2*pw(ix)
	   sr12=sr12+f(ix,4)*pw(ix)*glm_m(m+1)

	   call lgndr(Nmx,Lmx,m,cmn,cc,xc,glm_o)
	   f(ix,6)=glm_o(m+Kl)		! P^m_Kl
	   sum5=sum5+f(ix,6)**2*pw(ix)

	   call lgndr_0(Lmx,xc,glm_L)
	   f(ix,3)=glm_L(Lmx+Kl+1)
c   P(0,0),P(0,1),P(0,2)...P(0,Kl) 
	   sum2=sum2+f(ix,3)**2*pw(ix)

	   call lgndr_L(Lmx,Kl,xc,c,glm_L)
	   f(ix,5)=glm_L(m)		! P^m_Kl
c   P(1,Kl),P(2,Kl),P(3,Kl)...P(Kl,Kl) 
	   sum4=sum4+f(ix,5)**2*pw(ix)
c	   sr34=sr34+f(ix,4)*pw(ix)*glm(Kl)
	   fmm=F_mm(Kl,xc)
	   sum6=sum6+fmm*fmm*pw(ix)
	   write(10,21) (f(ix,ijk),ijk=1,6),fmm
  21	   format(10e15.6)
	enddo
	write(10,21) sumx,sum1,sum2,sum3,sum4,sum5,sum6
	write(10,21) sr12,sr34
	print*,'s2=',sum2,' s4=',sum4,' s5=',sum5
	print*,'sr12=',sr12,' sr34=',sr34

	RETURN
	END

C-----------------------------------------------------------
	SUBROUTINE lgndr_M(Lmx,m,cmm,c,x,glm)
C   Legandr functions F^m_k(x), k=m,m+1,...,Kmx 
      IMPLICIT REAL*8(a-h,o-y)
      DIMENSION glm(Lmx+1),c(2*Lmx+1)

	    xs=dsqrt(1.d0-x*x)
            glm(m+1)=cmm
            IF(m.GT.0) glm(m+1)=cmm*xs**m   ! P_m^m
	    if(m.eq.Lmx) return
	    glm(m+2)=x*c(m+1)*glm(m+1)	    ! P_m+1^m
 	    if(m+1.eq.Lmx) return
           DO k=m+2,Lmx			    ! P_m+l^m
               glm(k+1)=x*c(k)*glm(k)-c(Lmx+k)*glm(k-1)
           ENDDO
	return
	end
	
C-----------------------------------------------------------
	SUBROUTINE start_clm(Lmx,m,cmm,c)
        IMPLICIT REAL*8(a-h,o-y)
	dimension c(2*Lmx)
c	preparation of coefficients for recurrent 
c	relation for P_l^m
         cmm=.5D0
	if(m.gt.0) then
         DO k=2,2*m,2
            cmm=cmm*(k+1.)/k
         ENDDO
	endif
         cmm=(1-2*mod(m,2))*dsqrt(cmm)

         k=m+1
         c(k)=dsqrt((4*k*k-1.d0)/(k*k-m*m))
         c(Lmx+k)=0.
         DO k=m+2,Lmx
            c(k)=dsqrt((4.*k*k-1.d0)/(k*k-m*m))
            c(Lmx+k)=dsqrt((2.*k+1.d0)*((k-1.)*(k-1.)
     +			-m*m)/(2.*k-3.)/(k*k-m*m))
         ENDDO
	  return
	END
C-----------------------------------------------------------
	SUBROUTINE lgndr_0(Lmx,x,glm0)
C   Legandr polinomus F^0_l(x) 
      IMPLICIT REAL*8(a-h,o-y)
      DIMENSION glm0(2*Lmx+1)

	x2=x*x
        glm0(Lmx+1)=dsqrt(0.5d0)		!P_0
        glm0(Lmx+2)=dsqrt(1.5d0)*x		!P_1
        glm0(Lmx+3)=dsqrt(2.5d0)*(1.5d0*x2-0.5d0) !P_2
	if(Lmx.eq.2) return
        glm0(Lmx+4)=dsqrt(3.5d0)*x*(2.5d0*x2-1.5d0) !P_3
	if(Lmx.eq.3) return
        DO i=4,Lmx	
	   eps=1.-1./(i+0.)		! i=l
	   eps1=i+0.5d0	
	   eps2=dsqrt(eps1/(eps1-1.))		! 	
	   eps1=dsqrt(eps1/(eps1-2.))		! 	
	   j=Lmx+i+1	
           glm0(j)=x*(1.+eps)*eps2*glm0(j-1)-
     +		   eps*eps1*glm0(j-2)
        ENDDO

	return
	end
C-----------------------------------------------------------
	function F_mm(m,x)
        IMPLICIT REAL*8(a-h,o-y)
c	Legandr function F_m^m 
         cmm=.5D0
         DO k=2,2*m,2
            cmm=cmm*(k+1.)/k
         ENDDO
         cmm=(1-2*mod(m,2))*dsqrt(cmm)

	 xs=dsqrt(1.d0-x*x)
	 F_mm=cmm*xs**m
	  return
	END
C-----------------------------------------------------------
      SUBROUTINE tridag(abc,u,n,r1,rn)
        IMPLICIT REAL*8(a-h,o-y)
       dimension abc(4*n),u(n)
ccc    gam=abc(1:n),a=abc(n+1:2n),b=abc(2n+1:3n),c=abc(3n+1:4n)

	na=n
	nb=n+n
	nc=n+n+n
      if(abc(nb+1).eq.0.)pause 'tridag: rewrite equations'
      bet=abc(nb+1)
      u(1)=r1/bet
c           u(1)=r(1)/bet
      do 11 j=2,n
        abc(j)=abc(nc+j-1)/bet
        bet=abc(nb+j)-abc(na+j)*abc(j)
        if(bet.eq.0.)pause 'tridag failed'
        u(j)=-abc(na+j)*u(j-1)/bet
c             u(j)=(r(j)-a(j)*u(j-1))/bet
11    continue
        u(n)=(rn-abc(na+n)*u(n-1))/bet
      do 12 j=n-1,1,-1
        u(j)=u(j)-abc(j+1)*u(j+1)
12    continue

      return
      END
C-----------------------------------------------------------
	SUBROUTINE lgndr_L(Lmx,L,x,abc,glm)
C   Legandr functions F^m_L(x), m=1,2,...,L 
      IMPLICIT REAL*8(a-h,o-y)
      DIMENSION glm(2*Lmx+1),abc(4*Lmx)

	IF(L.eq.2) then
	   glm(1)=-dsqrt(3.75d0)*x*dsqrt(1.d0-x*x)
	   glm(2)=dsqrt(0.9375d0)*(1.-x*x)
	   return
	ENDIF

	IF(L.gt.2) THEN
	n=L-1
	nb=2*n
	nc=3*n
	xs=2.*x/dsqrt(1.d0-x*x)
C     abc(n+i)=a,abc(2n+i)=b,abc(3n+i)=c,
C   parameters of the matrix
	r1=-glm(Lmx+L+1)/dsqrt((1.-1./L)*(1.+1./(1.+L)))
	rf=-F_mm(L,x)
	abc(n+1)=0			! a(1)=0
	abc(nb+1)=xs/dsqrt(L*L+L-2.)	! b(1)=0
	abc(nc+1)=1.			! c(1)=1
	do m=1,L-2
	   e1=dsqrt((L-m-1.)*(L+m+2.) )
	   abc(n+m+1)=dsqrt((L-m)*(L+m+1.))/e1 	! a(m)
	   abc(nb+m+1)=xs*(m+1.)/e1		! b(m)
	   abc(nc+m+1)=1.			! c(m)=1
	enddo
	abc(nc+L-1)=0				! c(L)=0
	
	call tridag(abc,glm,n,r1,rf)
	glm(L)=-rf
	ENDIF
	return
	end
C-----------------------------------------------------------

	SUBROUTINE lgndr(Nmx,Kmx,m,cmm,c,x,glm)
C   Legandr functions F^m_k(x), k=m,m+1,...,Kmx 
      IMPLICIT REAL*8(a-h,o-y)
      DIMENSION glm(Kmx+1),c(2,Nmx)

	    xs=dsqrt(1.d0-x*x)
            glm(m+1)=cmm
            IF(m.GT.0) glm(m+1)=cmm*xs**m
	    if(m.eq.Kmx) return
	    glm(m+2)=x*c(1,m+1)*glm(m+1)
 	    if(m+1.eq.Kmx) return
           DO k=m+2,Kmx			
               glm(k+1)=x*c(1,k)*glm(k)-c(2,k)*glm(k-1)
           ENDDO
	return
	end
	
C-----------------------------------------------------------
	SUBROUTINE start_clmm(Nmx,Lmx,m,cmm,c)
        IMPLICIT REAL*8(a-h,o-y)
	dimension c(2,Nmx)
c	preparation of coefficients for recurrent 
c	relation for P_l^m
         cmm=.5D0
         DO k=2,2*m,2
            cmm=cmm*(k+1)/k
         ENDDO
         cmm=(1-2*mod(m,2))*dsqrt(cmm)

         DO l=m+2,Lmx
            c(1,l)=dsqrt((4*l*l-1.d0)/(l*l-m*m))
            c(2,l)=dsqrt((2*l+1.d0)*((l-1)**2-m*m)/(2*l-3)/(l*l-m*m))
         ENDDO
         l=m+1
         c(1,l)=dsqrt((4*l*l-1d0)/(l*l-m*m))
         c(2,l)=0.
	  return
	END
C  -------------------------------------------------------		
      SUBROUTINE get_name(name,i,j)
      CHARACTER*120 name
      CHARACTER*1   tab
      tab=char(9)
      DO i=1,120
         IF(name(i:i).NE.' '.AND.name(i:i).NE.tab) GOTO 1
      ENDDO
      i=1
      j=1
      RETURN
 1    CONTINUE
      DO j=i,120
         IF(name(j:j).EQ.' '.OR.name(j:j).EQ.tab) GOTO 2
      ENDDO
      j=121
 2    j=j-1
      IF(name(i:i).EQ.'''') i=i+1
      IF(name(j:j).EQ.'''') j=j-1
      END
C  -------------------------------------------------------		
      SUBROUTINE coord(Kx,K_fast,x1,x2,phi2,x,pw,Nx,Nph,Nphi)
	IMPLICIT REAL*8(a-h,o-z)
        dimension x(Nx),pw(Nx),Nph(Nx)

	  sx=0
	  call gauleg(x1,x2,x,pw,Nx)
	  do i=1,Nx
	    sx=sx+pw(i)
	  enddo

	if(x(Nx).gt.x2) x(Nx)=x2

	print*,'spw=',spw,' sx=',sx
	return
	end
* -------------------------------------------------------------------- *
	SUBROUTINE control(Nmx,Nmp,Jmx,K_fast,Nx,Nphi,
     +			Lmx,Kl,Ml)

	if(Kl.gt.Lmx) then
	    print*,'WARNING ! Kl > Lmx',Kl,Lmx
	    Kl=Lmx
	endif
	if(Ml.gt.Kl) then
	    print*,'WARNING ! Ml > Kl',Ml,Kl
	    Ml=Kl
	endif
	if(-Ml.gt.Kl) then
	    print*,'WARNING ! -Ml > Kl',Ml,Kl
	    Ml=-Kl
	endif

	if(Nx.gt.Nmx) then
	   print*,'Nx > Nmx=',Nmx
	   stop
	endif
	if(Nphi.gt.Nmp) then
	   print*,'Nphi > Nmp=',Nmp
	   stop
	endif
	if(Jmx.lt.Lmx) then
	   print*,'WARNING Nyquist !!! Lmx=',
     +			Lmx,' > Jmx=',Jmx
	endif
	if(Nmp.lt.4*Lmx) then
	   print*,'WARNING Nyquist !!! 2*Nmp=',
     +		2*Nmp,' < 4*Lmx=',4*Lmx
	   print*,'Let increase wsave(2*Npm) up to 4*Lmx'
	   stop
	endif
	return
	end


      SUBROUTINE gauleg(x1,x2,x,w,n)
	IMPLICIT REAL*8(a-h,o-z)
      INTEGER n
      dimension x(n),w(n)
      PARAMETER (EPS=3.d-15)
      INTEGER i,j,m
	pi=4.d0*atan(1.d0)
      m=(n+1)/2
      xm=0.5d0*(x2+x1)
      xl=0.5d0*(x2-x1)
      do 12 i=1,m
        z=cos(pi*(i-.25d0)/(n+.5d0))
1       continue
          p1=1.d0
          p2=0.d0
          do 11 j=1,n
            p3=p2
            p2=p1
            p1=((2.d0*j-1.d0)*z*p2-(j-1.d0)*p3)/j
11        continue
          pp=n*(z*p1-p2)/(z*z-1.d0)
          z1=z
          z=z1-p1/pp
        if(abs(z-z1).gt.EPS)goto 1
        x(i)=xm-xl*z
        x(n+1-i)=xm+xl*z
        w(i)=2.d0*xl/((1.d0-z*z)*pp*pp)
        w(n+1-i)=w(i)
12    continue
      return
      END
	
