#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define PR  fprintf
#define ER  stderr

int main(argc, argv)
int argc;
char **argv;
{
    int lmax = 100;
    int l=0, m;
    char str[81];
    double amp = 1.0, phase;
    FILE *fp;
    double *cl;

    if ((fp = fopen(argv[1], "r")) == (FILE *)0) {
	PR(ER, "can not open file '%s'...\n", argv[1]);
	exit(1);
    }

    while (fgets(str, 80, fp) != NULL) {
	    if (*str == '#' || *str == '\n')
		    continue;
	    sscanf (str, "%d%lf", &l, &amp);
	    if (lmax < l) lmax = l;
    }

    if((cl = (double *)calloc((unsigned)(lmax+1),sizeof *cl))==(double *)0) {
	PR(ER, "no memory...\n");
	exit(1);
    }

    fseek(fp, 0l, 0);
    while (fgets(str, 81, fp) != NULL) {
	    if (*str == '#' || *str == '\n')
		    continue;
	    sscanf (str, "%d%lf", &l, &amp);
	    cl[l] = amp;
    }

    for(l=2; l<=lmax; l++)   {
	amp = sqrt(cl[l] * (2*l +1));
	for(m=0; m<=l; m++) {
	     PR(stdout, "%4d %4d %12.5e\n", l, m, amp);
	}
    }

    exit(0);
}
