#include <stdio.h>
#include <math.h>

#define  ABS(x)         ((x) < 0 ? -(x) : (x))

void phase_calc(alm, nalm, phase, lmax)
double *alm, *phase;
int nalm, lmax;
{
	register int l, m;
	double pi = M_PI;

	for(l=0; l<=lmax; l++) {
	     int ll = l * nalm;
	     int lp = l * (lmax+1);
	     for(m=0; m<=l; m++) {
		  double re = alm[ll + m];
		  double im = alm[ll + m + lmax+1];
		  double ph;

		  if ( m == 0 ) {
			if (re < 0.0)  ph = pi;
			else    ph = 0.0;
		  } else {
			if ( ABS(re) < 1.e-30 ) {
			    if ( ABS(im) < 1.e-30 )
				ph = 0.0;
			    else
				if ( re * im < 0.0 )
				    ph = -pi/2;
				else
				    ph =  pi/2;
			} else
				ph = atan (im/re);

			if ( re < 0. && im > 0.) {
			      /* second quadrant           */
			      /* return ph from [-pi/2; 0] */
			      /* move it: (IV)->(II)       */
			      ph += pi;
			} else if ( re < 0. && im < 0.) {
			      /* third quadrant            */
			      /* return ph from [0; -pi/2] */
			      /* move it: (I)->(III)       */
			      ph += pi;
			} else if ( re > 0. && im < 0.) {
			      /* fourth quadrant           */
			      /* return ph from [-pi/2; 0] */
			      /* move it: (IV)->(IV)       */
			      ph += 2*pi;
			}
		  }
		  phase[lp+m] = ph;
	     }
	}

	return;
}
double ph_calc(re, im)
double re, im;
{
	double ph, pi = M_PI;

	if ( ABS(re) < 1.e-30 )
		ph = 0.0;
	else
		ph = atan (im/re);

	if ( re < 0. && im > 0.) {
	      /* second quadrant           */
	      /* return ph from [-pi/2; 0] */
	      /* move it: (IV)->(II)       */
	      ph += pi;
	} else if ( re < 0. && im < 0.) {
	      /* third quadrant            */
	      /* return ph from [0; -pi/2] */
	      /* move it: (I)->(III)       */
	      ph += pi;
	} else if ( re > 0. && im < 0.) {
	      /* fourth quadrant           */
	      /* return ph from [-pi/2; 0] */
	      /* move it: (IV)->(IV)       */
	      ph += 2*pi;
	}

	return ph;
}
double ang2phase(ang)
double ang;
{
	double ph=0.;
	return ph;
}
