#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "glesp.h"
#include "glespol.h"

#define MOD(a,p)   ((a) - (p) * (int)((a)/(p)))
#define PR      fprintf
#define ER      stderr

extern int max_double_();
extern int legendre_calc_scheme; /* if flag=-1, then direct calculations, */
				 /* else from largest M to lower          */

extern void a_lm_Pol(int *, int *, int *, int *, int *, int *, int *, int *,
      int *,int *,double *,double *,double *,double *,double *, int *,int *,
      double *,double *,double *,double *,double *,double *,
      double *,double *, int *, int *,
      double *,double *,double *,double *,
      double *,double *,double *,double *,double *,double *);

extern int  qu2sp_n(double *, double *, double *, int, int,
	      double *, double *, double *, double *, double *, double *,
	      int, int, int *, double, double, int *);



int  qu2sp_n(alm, s_alm, p_alm, lmax, nbuf, f, q, u,
		x, pw, pqu, nx, np, nph, eps1, eps2, Mmax)
double *alm, *s_alm, *p_alm;
int lmax, nbuf;
double *f, *q, *u, *x, *pw, *pqu;
int nx, np, *nph;
double eps1, eps2;
int *Mmax;
{
    int Nmx=nx, Jmx=(Nmx+1)/2,
//      Nmp = np > 2*Nmx ? np : 2*Nmx ;
	Nmp = np;
    register int l, m, ii, lmx1=lmax+1;
		    /* M-approach */
    int Kaml      = legendre_calc_scheme==0 ? -1 : legendre_calc_scheme,
	Ksym      = 1,
	K_pol     = (q != NULL || u != NULL ? 1 : -1),
	K_temp    = (f != NULL ? 1 : -1),
	Ktst    = 1;
    int Lmn=1, Lmx=lmax, Nx = nx, *Nph = nph;
    double *wsave = (double *)0, *cf=(double *)0, *sqx=(double *)0;
    double *xlbd=(double *)0;
    double *apm=(double *)0, *bpm=(double *)0,
	   *qc=(double *)0, *qs=(double *)0, *uc=(double *)0, *us=(double *)0;
    register int i, j;
    double *cpM=(double *)0, *cpL=(double *)0, *acL=(double *)0,
	   *abc=(double *)0, *cc=(double *)0, *glm=(double *)0,
	   *c=(double *)0;
    int Mlim = max_double_();
    static int mem_flag = -1;

    if ((wsave=(double *)calloc((2*Nmp+15), sizeof *wsave))==(double *)0) {
nomem:
	if (wsave != (double *)0)  free((void *)wsave);
	if (cf    != (double *)0)  free((void *)cf);
	if (xlbd  != (double *)0)  free((void *)xlbd);
	if (qc   != (double *)0)   free((void *)qc);
	if (qs   != (double *)0)   free((void *)qs);
	if (uc   != (double *)0)   free((void *)uc);
	if (us   != (double *)0)   free((void *)us);
	if (apm  != (double *)0)   free((void *)apm);
	if (bpm  != (double *)0)   free((void *)bpm);
	if (cpM  != (double *)0)   free((void *)cpM);
	if (cpL  != (double *)0)   free((void *)cpL);
	if (acL  != (double *)0)   free((void *)acL);
	if (abc  != (double *)0)   free((void *)abc);
	if (cc   != (double *)0)   free((void *)cc);
	if (sqx  != (double *)0)   free((void *)sqx);

	mem_flag -= 1;
	return mem_flag+1;
    }
    if ((cf = (double *)calloc(Nmp, sizeof *cf)) == (double *)0) goto nomem;
    if ((xlbd=(double*)calloc(2*Nmx+3,sizeof *xlbd))==(double*)0) goto nomem;

    if  (f != (double *)0) {
	if((apm=(double*)calloc(Nmx*(Jmx+1),sizeof *apm))==(double*)0)
	    goto nomem;
	if((bpm=(double*)calloc(Nmx*(Jmx+1),sizeof *bpm))==(double*)0)
	    goto nomem;
    }
    if  (q != (double *)0) {
	if((qc=(double*)calloc(Nmx*(Jmx+1),sizeof *qc))==(double*)0)
	    goto nomem;
	if((qs=(double*)calloc(Nmx*(Jmx+1),sizeof *qs))==(double*)0)
	    goto nomem;
	if((uc=(double*)calloc(Nmx*(Jmx+1),sizeof *uc))==(double*)0)
	    goto nomem;
	if((us=(double*)calloc(Nmx*(Jmx+1),sizeof *us))==(double*)0)
	    goto nomem;
    }
    l = (4*Jmx) * (Jmx+2);
    if ((cpM =(double *)calloc(l, sizeof *cpM)) == (double *)0) goto nomem;
    l = (3*Jmx) * (Jmx+1);
    if ((cpL =(double *)calloc(l, sizeof *cpL)) == (double *)0) goto nomem;
    l = (2*Jmx) * (Jmx+1);
    if ((acL =(double *)calloc(l, sizeof *acL)) == (double *)0) goto nomem;
    if ((abc =(double *)calloc(4*Jmx, sizeof *abc)) ==(double*)0) goto nomem;
    if ((cc =(double *)calloc(4*Jmx+4, sizeof *cc)) ==(double*)0) goto nomem;
    if ((sqx =(double *)calloc(Nmx, sizeof *sqx)) ==(double*)0) goto nomem;
    glm = wsave;
    c = wsave + 3 * Jmx + 6;

    for(ii=i=0; i<Nx; i++,ii+=Nmp) {
	register int n = Nph[i];
	register double p = pw[i];
	for(j=0; j<n; j++) {
	    register int ij = ii + j;
	    if (f != (double *)0)   f[ij] *= p;
	    if (q != (double *)0) {
		  q[ij] *= p;
		  u[ij] *= p;
	    }
	}
	if (Kaml > 0)
	    sqx[i] = sqrt(1.0-x[i]*x[i]+1.e-50);
    }

    /* small trick with polar pixel number: */
    /* doubling                             */
/*
    if (nph[0] < 6) {
	double bb[12];
	register int n = Nph[0], n2 = 2*n, ii = np * (nx-1);
	if (f != (double *)0) {
	    for(j=0; j<n;  j++)  bb[j*2] = bb[j*2+1] = f[j];
	    for(j=0; j<n2; j++)  f[j] = bb[j];
	    for(j=0; j<n;  j++)  bb[j*2] = bb[j*2+1] = f[ii+j];
	    for(j=0; j<n2; j++)  f[ii+j] = bb[j];
	}
	if (q != (double *)0) {
	    for(j=0; j<n;  j++)  bb[j*2] = bb[j*2+1] = q[j];
	    for(j=0; j<n2; j++)  q[j] = bb[j];
	    for(j=0; j<n;  j++)  bb[j*2] = bb[j*2+1] = q[ii+j];
	    for(j=0; j<n2; j++)  q[ii+j] = bb[j];
	}
	if (u != (double *)0) {
	    for(j=0; j<n;  j++)  bb[j*2] = bb[j*2+1] = u[j];
	    for(j=0; j<n2; j++)  u[j] = bb[j];
	    for(j=0; j<n;  j++)  bb[j*2] = bb[j*2+1] = u[ii+j];
	    for(j=0; j<n2; j++)  u[ii+j] = bb[j];
	}
	pw[0]     /= 2.;
	pw[nx-1]  /= 2.;
	nph[0]    *= 2.;
	nph[nx-1] *= 2.;
    }
*/

    /* a-lm calculation */
//    a_lm_pol(&Nmx,&Nmp,&Jmx,&Lmn,&Lmx,&Nx,&Ksym,&Kaml,&Ktst,
//            &K_temp,&eps,x,f,Nph,&Vnyq,wsave,cf,apm,bpm,
//            &K_pol,Ffh,Pfh,e,xlbd,pqu,pnrm,q,u,qc,uc,qs,us);

    if(K_pol > 0) {
	extern void norma_M(), norma_L(), start_Labc();
	if(Kaml < 0)  norma_M(&Jmx,&Lmn,&Lmx,cpL,cpM);
	if(Kaml > 0) {
	    start_Labc(Jmx,Lmx,Lmn,acL);
	    norma_L(&Jmx,&Lmn,&Lmx,cpL,cpM);
	}
    }
    a_lm_Pol(&Nmx, &Nmp, &Jmx, &Lmn, &Lmx, &Nx, &Ksym, &Kaml, &Ktst,
	    &K_temp, &eps1, &eps2, x, sqx, f,Nph, Mmax,
	    wsave,cf,glm, c,abc,cc,
	    apm,bpm, &Mlim,
	    &K_pol, cpL, cpM, acL,
	    xlbd, q,u,qc,uc,qs,us);

    for(l=0; l<=lmax; l++)  {
	for(m=0; m<=l; m++) {
	    register int lmr = l + nbuf * m,
			 lmi = l + nbuf * (m+lmx1);
	    /* and put minus */
	    if (f != (double *)0) {
		alm[lmr] =   -f[lmr];  alm[lmi] =   -f[lmi];
	    }
	    if (q != (double *)0) {
		s_alm[lmr] = -q[lmr];  s_alm[lmi] = -q[lmi];
		p_alm[lmr] = -u[lmr];  p_alm[lmi] = -u[lmi];
	    }
	}
    }


//    for(ll=lb=l=0; l<=lmax; l++,ll+=Nmp,lb+=nbuf)  {
//        register int lbi = lb + lmx1;
//        double ss = 0.0, sp = 0.0;
//        for(m=0; m<=l; m++) {
//            register int lmb = lb + m, lmbi = lbi + m;
//            double sa = s_alm[lmb] * s_alm[lmb] + s_alm[lmbi] * s_alm[lmbi];
//            double pa = p_alm[lmb] * p_alm[lmb] + p_alm[lmbi] * p_alm[lmbi];
//            ss += sa;
//            sp += pa;
//        }
//        PR(ER, "l=%d, ss=%16.9e, sp=%16.9e\n", l, ss, sp);
//    }

    /* free memory */
    if(wsave != (double *)0)    free((void *)wsave);
    if(cf    != (double *)0)    free((void *)cf);
    if(xlbd  != (double *)0)    free((void *)xlbd);
    if(apm   != (double *)0)    free((void *)apm);
    if(bpm   != (double *)0)    free((void *)bpm);
    if(qc    != (double *)0)    free((void *)qc);
    if(qs    != (double *)0)    free((void *)qs);
    if(uc    != (double *)0)    free((void *)uc);
    if(us    != (double *)0)    free((void *)us);

    if(cpM   != (double *)0)    free((void *)cpM);
    if(cpL   != (double *)0)    free((void *)cpL);
    if(acL   != (double *)0)    free((void *)acL);
    if(abc   != (double *)0)    free((void *)abc);
    if(cc    != (double *)0)    free((void *)cc);
    if(sqx   != (double *)0)    free((void *)sqx);

    return 0;
}
