#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#include "glesp.h"

#define PR      fprintf
#define ER      stderr

int  read_obs_n(char *name)
{

	return 0;
}

void read_obs_data(filename, ot, n)
char *filename;
struct _obs_ **ot;
int *n;
{
	double *m_f =(double *)0, *m_x = (double *)0;
	int *m_nph = (int *)0;
	int m_nx, m_nphi;
	register int i, j, k;

	/* read data of map from T-file, just for test */
	read_map2(&m_f, &m_nx, &m_nphi, &m_nph, &m_x, filename);

	*n = 0;
	for(i=0; i<m_nx; i++)  *n += m_nph[i];

	/* find memory for array */
	*ot = (struct _obs_ *)calloc(*n, sizeof **ot);
	if (*ot == (struct _obs_ *)0) {
		PR(ER, "%s: no memory for observational data...\n", myname);
		exit(1);
	}

	/* fill in observational data array */
	for(k=i=0; i<m_nx; i++) {
		int ii = i * m_nphi;
		double dphi = 2.*M_PI/ m_nph[i];
		for(j=0; j<m_nph[i]; j++) {
			(*ot)[k].theta = acos(m_x[i]);
			(*ot)[k].phi   = dphi * j;
			(*ot)[k].t     = m_f[ii+j];
			k++;
		}
	}

	if(m_f == (double *)0)  free((void *)m_f);
	if(m_x == (double *)0)  free((void *)m_x);
	if(m_nph == (int *)0)   free((void *)m_nph);

	return;
}
