       SUBROUTINE signal(Lmn,Lmx,Nx,eps,phi2,
     +          Nmx,Nmp,Jmx, x,pw,f,Nph,
     +          wsave,cf,apm,bpm,
     +          K_fast,Ksym,Kml)
c      SUBROUTINE signal(Lmn,Lmx,Nx,eps,phi2)
C transformation of the a_lm to the map
c       include 'mem.inc'
	 IMPLICIT REAL*8(a-h,o-y)
C       parameter(Nmx=2001,Jmx=(Nmx+1)/2,Nmp=2*Nmx)
C       common/main/ x(Nmx),pw(Nmx),f(Nmx,Nmp),Nph(Nmx)
C   service arrays
C       common/serv/ wsave(2*Nmp+15),cf(Nmp)
C       common/abpm/ apm(0:Jmx,Nmx),bpm(0:Jmx,Nmx)
C       common/key/K_alm_map,Kx,K_fast,Ksym,Kml

	DIMENSION x(Nmx),pw(Nmx),f(Nmx*Nmp),Nph(Nmx)
	DIMENSION apm((Jmx+1)*Nmx),bpm((Jmx+1)*Nmx)
	DIMENSION wsave(2*Nmp+15),cf(Nmp)

* -------------------------------------------------------------------- *
C   input parameters: x(Nx) Nph(Nmx) - coordinates on 
C   the sphere, f(2:Lmx,1:Lmx+1) - real a_lm, 
C               f(2:Lmx,Lmx+2:2*Lmx+2) - imag a_lm,
C   output parameter: f(Nmx,Nmp) signal in points x, phi
* -------------------------------------------------------------------- *

      sum = 0.0

C     set dipole
      i_dip_flag = 0
      if((Kml.eq.0.or.Kml.eq.100).and.Lmx.lt.0) then
	   Lmx = -Lmx
	   if(Kml.eq.100) then
		Kml = -1
	   endif
	   i_dip_flag = 1
      endif

!$omp parallel do
!$omp+ shared(Lmx,Nmp,f)
!$omp+ private(L,LL,m)
      DO L=2,Lmx
	 LL=L*Nmp
c        f(L,1)=1.4142136d0*f(l,1)
	 f(LL+1)=1.41421356237309504880d0*f(LL+1)
c          sum = sum + f(LL+1)*  f(LL+1)
	 DO m=1,L
c               f(L,m)=2.d0*f(L,m)
c               f(L,Lmx+1+m)= -2.d0*f(L,Lmx+1+m)
		f(LL+m+1)    =  2.d0*f(LL+m+1)
		f(LL+Lmx+2+m)= -2.d0*f(LL+Lmx+2+m)
c                 sum = sum + f(LL+ m+1)    * f(LL+ m+1)
c                 sum = sum + f(LL+Lmx+2+m) * f(LL+Lmx+2+m)
	 ENDDO
      ENDDO
c       print *, 'sum(f)=',sum
!$omp end parallel do

C They are equal 0, because of C-function calloc...
c!$omp parallel do
c!$omp+ shared(Jmx,Nmx,apm,bpm)
c!$omp+ private(m,mm,ix)
c     DO m=0,Jmx
c        mm = m * Nmx
c        DO ix=1,Nmx
c           apm(mm+ix)=0.
c           bpm(mm+ix)=0.
c        ENDDO
c     ENDDO
c!$omp end parallel do

C   loop over l - SUM_l[a_{lm}P_l^m(x_p)]

C       set dipole
	if(i_dip_flag.eq.1) then
	     call  sig_dipole(Nmx,Nmp,Jmx,Lmn,Lmx,Ksym, Nx,x,f,apm,bpm)
	endif

	if(Kml.lt.0) then
            print*,'sig-lgndr_M, Kml=',Kml, 
     +          ' Kfast=',K_fast,' Ksym=',Ksym
	    call sig_lgndr_M(Nmx,Nmp,Jmx,Lmn,Lmx,
     +              Ksym,eps,Nx,x,f,cf,wsave,apm,bpm)
        endif
       if(Kml.gt.0) then
	   print*,'sig-lgndr_L, Kml=',Kml,
     +         ' Kfast=',K_fast,' Ksym=',Ksym
	   call sig_lgndr_L(Nmx,Nmp,Jmx,Lmn,Lmx,
     +          Ksym,eps,Nx,x,f,cf,wsave,apm,bpm)
        endif
	do i=1,Nmx
	     mm = (i-1)*Nmp
	     do j=1,Nmp
	       f(mm+j)=0
	     enddo
	enddo

C   loop over m - SUM_m[a_{lm}e^{i m phi}]
        if(K_fast.lt.0) call sig_phi(Nmx,Nmp,Jmx,Lmx,
     +    Nx,Nph,cf,phi2,apm,bpm,wsave,f)

        print*,'sig-fast'
        if(K_fast.gt.0) call sig_fast3(Nmx,Nmp,Jmx,
     +          Lmx,Nx,Nph,apm,bpm,cf,f,wsave)

C renormalization and test of integral
        pi=4.d0*atan(1.d0)
	cnorm=1./dsqrt(pi)      ! factor 2 due to m & -m
	cnorm=cnorm/sqrt(2.)
	ss=0
        sum=0

!$omp parallel do
!$omp+ shared(Nx,Nmp,Nph,f,pw,cnorm)
!$omp+ private(i,ii,j)
!$omp+ reduction(+:ss, sum)
	do i=1,Nx
	    ii = (i-1)*Nmp
	    do j=1,Nph(i)
c               f(i,j)=cnorm*f(i,j)
c               sum=sum+f(i,j)**2/Nph(i)
c               ss=ss+f(i,j)**2*pw(i)
c               f(i,j)=f(i,j)*pw(i)
		f(ii+j)=cnorm*f(ii+j)
		sum=sum+f(ii+j)**2/Nph(i)
		ss=ss+f(ii+j)**2*pw(i)
c               f(ii+j)=f(ii+j)*pw(i)
	    enddo
	enddo
!$omp end parallel do
C   here f(i,j) is the map

	print*,'sum f**2=',2*ss,' summ=',sum, ' Nx=', Nx

      RETURN
      END

C-----------------------------------------------------------
        SUBROUTINE sig_lgndr_M(Nmx,Nmp,Jmx,Lmn,Lmx,Ksym,
     +                  eps,Nx,x,f,glm,c,apm,bpm)
C   loop over l - SUM_l[a_{lm}P_l^m(x_p)]
C    input: f(i,j)=alm, x(ix)
C   output: apm,bpm (m,ix)
      IMPLICIT REAL*8(a-h,o-y)
c     DIMENSION x(Nx),f(Nmx,Nmp)
      DIMENSION x(Nx),f(Nmx*Nmp)
      DIMENSION c(2*Lmx+1),glm(Lmx+1)
c     DIMENSION apm(0:Jmx,Nmx),bpm(0:Jmx,Nmx)
      DIMENSION apm((Jmx+1)*Nmx),bpm((Jmx+1)*Nmx)

      sum_a=0
      sum_b=0
      Kx=Nx
      mb=Lmx+2
      if(Ksym.gt.0) Kx=(Nx+1)/2

!$omp parallel do
!$omp+ private(m,cmm,mm,glm,ix,xc,c,L0,LL,L,jx,ax)
!$omp+ shared(Lmx,Nmx,Kx,Lmn,Nmp,apm,bpm,f,Nx,x)
!$omp+ reduction(+:sum_a, sum_b)
      DO m=0,Lmx                        ! for all m
	 mm = m * Nmx
	 call start_clm(Lmx,m,cmm,c)
	 DO ix=1,Kx                     ! loop over x(ix)
	      xc=x(ix)
	      call lgndr_M(Lmx,m,cmm,c,xc,glm)
              L0=m
              if(L0.lt.Lmn) L0=Lmn 
ccc   if(m.lt.5.and.ix.lt.2) print *,cmm,c(L0+3),glm(L0+3)
              DO L=L0,Lmx                       ! loop over L
		 LL = L * Nmp
		 if(dabs(glm(L+1)).gt.eps) then
		   apm(mm+ix)=apm(mm+ix)+glm(L+1)*f(LL+m+1)
		   bpm(mm+ix)=bpm(mm+ix)-glm(L+1)*f(LL+mb+m)
ccc   if(m.lt.5.and.ix.lt.2.and.L.eq.L0) print *,f(LL+m+1),f(LL+mb+m)
		   IF(Kx.lt.Nx) THEN            ! for symmetric x
		     jx=Nx-ix+1
		     if(ix.lt.jx) then
		       ax=1-2*mod((L+m),2)
		       apm(mm+jx)=apm(mm+jx)+ax*glm(L+1)*f(LL+m+1)
		       bpm(mm+jx)=bpm(mm+jx)-ax*glm(L+1)*f(LL+mb+m)
		     endif
		   ENDIF           ! for symmetric x
		 endif             ! for glm< eps
              ENDDO             ! end of loop over L
C   test for sum_a, sum_b
	      sum_a=sum_a+apm(mm+ix)**2
	      sum_b=sum_b+bpm(mm+ix)**2
ccc   if(m.lt.5.and.ix.lt.2) print *,apm(mm+ix),bpm(mm+ix)
              IF(Kx.lt.Nx) THEN
                jx=Nx-ix+1
                if(ix.lt.jx) then
		  sum_a=sum_a+apm(mm+jx)**2
		  sum_b=sum_b+bpm(mm+jx)**2
                endif
              ENDIF              ! for sum Kx < Nx
         ENDDO                   ! loop over x
      ENDDO                      ! loop over m
!$omp end parallel do

      print*,'sum_a_M=',sum_a,' sum_b_M=',sum_b

      return
      end
C-----------------------------------------------------------
        SUBROUTINE sig_lgndr_L(Nmx,Nmp,Jmx,Lmn,Lmx,Ksym,
     +               eps,Nx,x,f,glm,abc,apm,bpm)
C   loop over l - SUM_l[a_{lm}P_l^m(x_p)]
C    input: f(i,j)=alm, x(ix)
C   output: apm,bpm (m,ix)
      IMPLICIT REAL*8(a-h,o-y), COMPLEX*16(z)
c     DIMENSION x(Nx),f(Nmx,Nmp)
c     DIMENSION apm(0:Jmx,Nmx),bpm(0:Jmx,Nmx)
      DIMENSION x(Nx),f(Nmx*Nmp)
      DIMENSION apm((Jmx+1)*Nmx),bpm((Jmx+1)*Nmx)
      DIMENSION abc(4*Lmx),glm(2*Lmx+1)
C     glm=cf(Nmp),abc=wsave(2*Nmp+15)

      sum_a=0
      sum_b=0
      ax=0
      mb=Lmx+2
      Kx=Nx
      if(Ksym.gt.0) Kx=(Nx+1)/2          !for symmetric x
      DO ix=1,Kx                         ! integral over x(ix)
          xc=x(ix)
          call lgndr_0(Lmx,xc,glm)            ! P_L^0(ix),L<Lmx
          DO L=Lmn,Lmx                        ! for all L
C   for m=0
	   LL = L * Nmp
	   LL0=Lmx+L+1
	   if(dabs(glm(LL0)).gt.eps) then
c              apm(0,ix)=apm(0,ix)+glm(LL0)*f(L,1)
c              bpm(0,ix)=bpm(0,ix)-glm(LL0)*f(L,mb)
	       apm(ix)=apm(ix)+glm(LL0)*f(LL+1)
	       bpm(ix)=bpm(ix)-glm(LL0)*f(LL+mb)
	       IF(Kx.lt.Nx) THEN          ! for symmetric x(ix)
		   jx=Nx-ix+1
		   if(jx.gt.ix) then
		       ax=1-2*mod(L,2)
c                      apm(0,jx)=apm(0,jx)+ax*glm(LL0)*f(L,1)
c                      bpm(0,jx)=bpm(0,jx)-ax*glm(LL0)*f(L,mb)
		       apm(jx)=apm(jx)+ax*glm(LL0)*f(LL+1)
		       bpm(jx)=bpm(jx)-ax*glm(LL0)*f(LL+mb)
		   endif
	       ENDIF
	    endif                ! for glm< eps
	    call lgndr_L(Lmx,L,xc,abc,glm)    ! P_L^m(ix),1<m<L
	    DO m=1,L
	      if(dabs(glm(m)).gt.eps) then
		mm = m * Nmx
c               apm(m,ix)=apm(m,ix)+glm(m)*f(L,m+1)
c               bpm(m,ix)=bpm(m,ix)-glm(m)*f(L,mb+m)
		apm(mm+ix)=apm(mm+ix)+glm(m)*f(LL+m+1)
		bpm(mm+ix)=bpm(mm+ix)-glm(m)*f(LL+mb+m)
                IF(Kx.lt.Nx) THEN       ! for symmetric x(ix)
                  jx=Nx-ix+1
                  if(jx.gt.ix) then
                    ax=1-2*mod((L+m),2)
c                   apm(m,jx)=apm(m,jx)+ax*glm(m)*f(L,m+1)
c                   bpm(m,jx)=bpm(m,jx)-ax*glm(m)*f(L,mb+m)
		    apm(mm+jx)=apm(mm+jx)+ax*glm(m)*f(LL+m+1)
		    bpm(mm+jx)=bpm(mm+jx)-ax*glm(m)*f(LL+mb+m)
                  endif
                ENDIF
	      endif              ! for glm< eps
	    ENDDO                ! over all 1<m<L
	  ENDDO                  ! over all L

	  DO m=0,Lmx             ! test for sum
	    mm = m * Nmx
c           sum_a=sum_a+apm(m,ix)**2
c           sum_b=sum_b+bpm(m,ix)**2
	    sum_a=sum_a+apm(mm+ix)**2
	    sum_b=sum_b+bpm(mm+ix)**2
	    IF(Kx.lt.Nx) THEN           ! for symmetric x(ix)
	      jx=Nx-ix+1
	      if(jx.gt.ix) then
c               sum_a=sum_a+apm(m,jx)**2
c               sum_b=sum_b+bpm(m,jx)**2
		sum_a=sum_a+apm(mm+jx)**2
		sum_b=sum_b+bpm(mm+jx)**2
	      endif
	    ENDIF
	  ENDDO
      ENDDO                                   ! end for x(ix)
      print*,'sum_a_L=',sum_a,' sum_b_L=',sum_b

      return
      end
C-----------------------------------------------------------
	SUBROUTINE sig_dipole(Nmx,Nmp,Jmx,Lmn,Lmx,Ksym,
     +                  Nx,x,f,apm,bpm)
C   loop over l - SUM_l[a_{lm}P_l^m(x_p)]
C    input: f(i,j)=alm, x(ix)
C   output: apm,bpm (m,ix)
      IMPLICIT REAL*8(a-h,o-y)
c     DIMENSION x(Nx),f(Nmx,Nmp)
      DIMENSION x(Nx),f(Nmx*Nmp)
c     DIMENSION apm(0:Jmx,Nmx),bpm(0:Jmx,Nmx)
      DIMENSION apm((Jmx+1)*Nmx),bpm((Jmx+1)*Nmx)

      Kx=Nx
      mb=Lmx+3
      if(Ksym.gt.0) Kx=(Nx+1)/2
      pi=4.*atan(1.d0)
      cnorm = dsqrt(3.)
      L1 = Nmp

      print *, 'dipole calculation'

c      f(L1+2)   =  0.5 * f(L1+2)
c      f(L1+mb)  =  0.5 * f(L1+mb)

      DO ix=1,Kx                     ! loop over x(ix)
	   xc = -dsqrt(1.-x(ix)**2)
	   xc = xc * cnorm

	   apm(ix)=apm(ix)+x(ix)*f(L1+1) * cnorm
	   apm(Nmx+ix)=apm(Nmx+ix)+xc*f(L1+2)
	   bpm(Nmx+ix)=bpm(Nmx+ix)+xc*f(L1+mb)

	   IF(Kx.lt.Nx) THEN            ! for symmetric x
	     jx=Nx-ix+1
	     if(ix.lt.jx) then
	       apm(jx)=apm(jx)-x(ix)*f(L1+1) * cnorm
	       apm(Nmx+jx)=apm(Nmx+jx)+xc*f(L1+2)
	       bpm(Nmx+jx)=bpm(Nmx+jx)+xc*f(L1+mb)
	     endif
	   ENDIF        ! for symmetric x
      ENDDO             ! loop over x

      return
      end
